<template>
    <div class="flex-center-box-container">
        <div class="flex-center-box-box">
            <h1>LOGIN</h1>
            <BForm>
                <BaseValidationInput
                    input-label="Email"
                    :input-value="form.email"
                    input-name="loginEmail"
                    inputType="text"
                    @update="form.email = $event"
                />
                <BaseValidationInput
                    input-label="Password"
                    :input-value="form.password"
                    input-name="loginPassword"
                    inputType="password"
                    @update="form.password = $event"
                />
                <BButton type="button" variant="primary" class="full-width mt-4" @click.prevent="login()">
                    <BSpinner variant="light" v-show="isLoading"></BSpinner>
                    <span class="whiteText" v-show="!isLoading"> login </span>
                </BButton>
            </BForm>
            <div class="mt-3">
                <span class="flex-center-box-other-text"> Don’t have account? </span>
                <router-link to="/register">
                    <span class="flex-center-box-other-link pointer"> Register Now </span>
                </router-link>
            </div>
        </div>
    </div>
</template>

<script>
import BaseValidationInput from '@/components/Base/BaseValidationInput';
export default {
    name: 'AppLogin',
    components: {
        BaseValidationInput,
    },
    data() {
        return {
            form: {
                password: '',
                email: '',
            },
            isLoading: false,
        };
    },
    methods: {
        login() {
            console.log('form', this.form);
            this.$validator.validateAll().then(async (isOkeyValidation) => {
                if (isOkeyValidation) {
                    this.isLoading = true;
                    const response = await this.$root.axiosApiCall(
                        'Login Failed',
                        'post',
                        'users/login',
                        {},
                        {
                            user: this.form,
                        },
                    );
                    console.log('response', response);
                    if (response && response.status == '200') {
                        /*set to cookie*/
                        this.$cookie.set(
                            'auth',
                            JSON.stringify({
                                name: response.data.user.username,
                                token: response.data.user.token,
                            }),
                        );
                        /*redirect to article*/
                        this.$router.push('article');
                    }
                    this.isLoading = false;
                }
            });
        },
    },
    provide() {
        return {
            $validator: this.$validator,
        };
    },
};
</script>

<style scoped lang="scss">
@import '../includes/styles/flex-center-box';
</style>
